<?php
/*---------------------------------------------------------------*/
/*
    Titre : Carr magique                                                                                                 
                                                                                                                          
    URL   : https://phpsources.net/code_s.php?id=945
    Date dition     : 15 Fv 2019                                                                                        
*/
/*---------------------------------------------------------------*/

function carre_magique($carre){ 
 # verification du carre 
  if (!is_array($carre)){ return 0;} 
  
  $len = count($carre); 
  foreach ($carre as $c){ 
  if (!is_array($c) || (count($c) != $len) || !is_int($c)){ return -3;}
  } 
  
 # somme du carre (fonction de sa taille) 
  $sum=$len*($len*$len+1)/2; 
  
 # Verification des lignes et colonnes 
  for ($i=0;$i<$len;$i++) { 
  $j=0; 
  $line1=0; 
  $line2=0; 
  for ($j=0;$j<$len;$j++) { 
  $line1+=$carre[$i][$j]; 
  $line2+=$carre[$j][$i]; 
  } 
  if ($line1 != $sum || $line2 != $sum) { 
 # Ce n'est pas un carre magique 
  return(0); 
  } 
  } 
 # Verification des colonnes 
  for ($j=0;$j<$len;$j++) { 
  $i=0; 
  $diag1=0; 
  $diag2=0; 
  for ($i=0; $i<$len; $i++) { 
  $diag1 += $carre[$i][($i+$j) % $len]; 
  $diag2 += $carre[$len-1-$i][($i+$j) % $len]; 
  } 
  if ($j == 0) { 
  if ($diag1 != $sum || $diag2 != $sum) { 
 # carre semi magique : les diagnoles n'en sont pas 
  return 1; 
  } 
  } else { 
  if ($diag1 != $sum || $diag2 != $sum) { 
 # carre magique : les colonnes, les lignes et les diagonales 
  return 2; 
  } 
  } 
  } 
 # Super carre magique : toutes les diagonales 
  return 3; 
 // librement adapt de MagicSquare par Fabrizio Pivari Italy 
}

?>